unit v7mysql.module;

interface

uses
  SysUtils, Classes, AddinHelper;

type
  TModule = class(TDataModule)
    AddinHelper: TAddinHelper;
    procedure AddinHelperGetProperty(Sender: TObject;
      const PropertyName: string; var Value: OleVariant;
      var Handled: Boolean);
    procedure AddinHelperFindProperty(Sender: TObject;
      const PropertyName: string; var Index: Integer);
    procedure AddinHelperIsPropertyWriteable(Sender: TObject;
      const PropertyName: string; var Writeable: Boolean);
    procedure AddinHelperIsPropertyReadable(Sender: TObject;
      const PropertyName: string; var Readable: Boolean);
    procedure AddinHelperGetPropertyName(Sender: TObject;
      var PropertyName: WideString; const Index, Alias: Integer);
    procedure AddinHelperGetPropertyCount(Sender: TObject;
      var Count: Integer);
    procedure AddinHelperMethodsCloneCallAsFunc(Sender: TObject;
      var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsListProcessesCallAsProc(Sender: TObject;
      var Params: array of Variant);
    procedure AddinHelperMethodsListProcessesCallAsFunc(Sender: TObject;
      var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsListProcessesGetDefaultParam(
      Sender: TObject; const Index: Integer; var Value: OleVariant);
    procedure AddinHelperMethodsFillAllCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsFillAllCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsFetchAllGetDefaultParam(Sender: TObject; const Index: Integer; var Value: OleVariant);
    procedure AddinHelperMethodsFetchAllCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsFetchAllCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsFetchRowGetDefaultParam(Sender: TObject; const Index: Integer; var Value: OleVariant);
    procedure AddinHelperMethodsFetchRowCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsFetchRowCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsFetchValueCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsLocateCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsLastCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsFirstCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsPriorCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsNextCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsFieldTypeCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsFieldDefGetDefaultParam(Sender: TObject; const Index: Integer; var Value: OleVariant);
    procedure AddinHelperMethodsFieldDefCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsBOFCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsEOFCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsLastRowReadCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsExecuteGetDefaultParam(Sender: TObject; const Index: Integer; var Value: OleVariant);
    procedure AddinHelperMethodsExecuteCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsExecuteCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsQueryGetDefaultParam(Sender: TObject; const Index: Integer; var Value: OleVariant);
    procedure AddinHelperMethodsQueryCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsQueryCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsStatCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsShutdownCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsShutdownCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsPingCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsKillCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsKillCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsRefreshCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsRefreshCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsChangeUserGetDefaultParam(Sender: TObject; const Index: Integer; var Value: OleVariant);
    procedure AddinHelperMethodsChangeUserCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsChangeUserCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsDropDbCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsDropDbCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsCreateDbCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsCreateDbCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsSelectDbCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsSelectDbCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsCloseCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsReconnectCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsReconnectCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsConnectCallAsProc(Sender: TObject; var Params: array of Variant);
    procedure AddinHelperMethodsConnectCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsConnectedCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsLastErrorNoCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsLastErrorCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsInfoCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperMethodsExtraInfoCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsServerLanguageCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsServerStatusCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsServerCapabilitiesCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsProtocolVersionCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsClientVersionCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsServerVersionCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsLastInsertIdCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsAffectedRowsCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsThreadIdCallAsFunc(Sender: TObject; var Params: array of Variant;
      var Value: OleVariant);
    procedure AddinHelperMethodsStatusCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
    procedure AddinHelperPropertiesUseNewPasswordSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesAutoTypeSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesCompressSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesConnectTimeoutSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesTrySocketsSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesUseNamedPipeSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesShouldReconnectSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesClientFlagSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesPortSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesDbSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesUnixSocketSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesPasswordSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesUseNewPasswordGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesAutoTypeGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesResultTypeGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesRowsCountGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesFieldsCountGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesRecNoGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesCompressGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesConnectTimeoutGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesTrySocketsGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesUseNamedPipeGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesShouldReconnectGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesClientFlagGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesPortGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesDbGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesUnixSocketGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesPasswordGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesUserSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesUserGet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesHostSet(Sender: TObject; var Value: OleVariant);
    procedure AddinHelperPropertiesHostGet(Sender: TObject; var Value: OleVariant);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Module: TModule;

implementation
uses  Windows, ActiveX, ComServ, ComObj,
      Math, Variants, FMTBcd, StrUtils, Contnrs,
      AddInLib, AddinComObjectUnit,
      uMysqlCT, uMysqlClient;

{$R *.dfm}

const
  CLSID_MySQLConnection : TGUID = '{77301E1E-7923-42D7-9B73-1B94C1B8649B}';

var
  MysqlFormatSettings: TFormatSettings;

type

  TMySQLConnection = class (TAddin)
  protected
    function AddinInit: HResult; override;
    function AddinDone: HResult; override;
  public
    Client: TMysqlClient;
    Query: TMysqlResult;
    AutoType: Boolean;
    function PrepareSQL(const OleSQL, Params: OleVariant): String;
    function GetFieldValue(AIndex: Integer): OleVariant;
    function GetFieldType(AIndex: Integer): OleVariant;
    function ListProcesses(const Param: Variant): Variant;
    function FetchAll(const Param: Variant): Variant;
    function CreateDB(const DBName:String): Boolean;
    function DropDB(const DBName:String): Boolean;
  end;

{ TMySQLConnection }

function TMySQLConnection.AddinDone: HResult;
begin
  if Assigned(Client) then FreeAndNil(Client);
  if Assigned(Query) then FreeAndNil(Query);
  Result:= inherited AddinDone;
end;

function TMySQLConnection.AddinInit: HResult;
begin
  Result:= inherited AddinInit;
  Helper:= Module.AddinHelper;
  Client:= TMysqlClient.create;
  Query:= nil;
end;

function TMySQLConnection.CreateDB(const DBName: String): Boolean;
var
  r: TMysqlResult;
begin
  Result:= False;
  if not Assigned(Client) then Exit;
  if Client.ServerVersion < '5.0.84' then Result:= Client.create_db(DBName)
  else begin
    r:= Client.query('create database `'+DBName+'`;',false,Result);
    if Assigned(r) then FreeAndNil(r);
  end;
end;

function TMySQLConnection.DropDB(const DBName: String): Boolean;
var
  r: TMysqlResult;
begin
  Result:= False;
  if not Assigned(Client) then Exit;
  if Client.ServerVersion < '5.0.84' then Result:= Client.drop_db(DBName)
  else begin
    r:= Client.query('drop database `'+DBName+'`;',false,Result);
    if Assigned(r) then FreeAndNil(r);
  end;
end;

function TMySQLConnection.FetchAll(const Param: Variant): Variant;
var V: Variant;
    I, J, K: Integer;
    NewTable: Boolean;
begin
  pStatusLine.ResetStatusLine;
  Result:= Param;
  NewTable:= IsEmptyParam(Result);
  if NewTable then begin
    if IsV77Application then Result:= GetApplication.EvalExpr('CreateObject("ValueTable")') else Result:= GetApplication.NewObject('ValueTable')
  end else begin
    if IsV77Application then Result.DeleteLines else Result.Clear;
  end;
  if Assigned(Query) then try
    if IsV77Application then begin
      if NewTable then
        for I:= 0 to Query.FieldsCount - 1 do
          Result.NewColumn(String(Query.FieldDef(I)^.Name),GetFieldType(I));
    end else begin
      if NewTable then
        for I:= 0 to Query.FieldsCount - 1 do
          Result.Columns.Add(String(Query.FieldDef(I)^.Name));
    end;
    Query.First; J:= 1;
    while not Query.EOF do begin
      pStatusLine.SetStatusLine('Fetching... '+IntToStr(J));
      if IsV77Application then begin
        Result.NewLine(J);
        if NewTable then
          for I:= 0 to Query.FieldsCount - 1 do Result.SetValue(J,I+1,GetFieldValue(I))
        else
          for I:= 1 to Result.ColumnCount do begin
            K:= Query.FieldIndexByName(String(Result.GetColumnParameters(I)),False);
            if K > -1 then Result.SetValue(J,I,GetFieldValue(K));
          end;
      end else begin
        V:= Result.Add();
        if NewTable then
          for I:= 0 to Query.FieldsCount - 1 do V.Set(I,GetFieldValue(I))
        else
          for I:= 0 to Result.Columns.Count-1 do begin
            K:= Query.FieldIndexByName(String(Result.Columns.Get(I).Name),False);
            if K > -1 then V.Set(I,GetFieldValue(K));
          end;
      end;
      Inc(J);
      Query.Next;
    end;
    pStatusLine.SetStatusLine('Fetching... done.');
  except end;
  pStatusLine.ResetStatusLine;
end;

function TMySQLConnection.GetFieldType(AIndex: Integer): OleVariant;
begin
  if AutoType then Result:= Unassigned
  else
  case Query.FieldDef(aIndex)^.field_type of
          FIELD_TYPE_TINY,
          FIELD_TYPE_SHORT,
          FIELD_TYPE_LONG,
          FIELD_TYPE_YEAR,
          FIELD_TYPE_LONGLONG,
          FIELD_TYPE_INT24,
          FIELD_TYPE_DECIMAL,
          FIELD_TYPE_FLOAT,
          FIELD_TYPE_DOUBLE
                            : Result:= 'Number';
          FIELD_TYPE_TIMESTAMP,
          FIELD_TYPE_DATETIME,
          FIELD_TYPE_TIME
                            : Result:= 'String';
          FIELD_TYPE_DATE,
          FIELD_TYPE_NEWDATE
                            : Result:= 'Date';
  else Result:= 'String'
  end;
end;

function TMySQLConnection.GetFieldValue(AIndex: Integer): OleVariant;
var S: String;
begin
  S := Query.FieldValue(aIndex);
  case Query.FieldDef(aIndex)^.field_type of
          FIELD_TYPE_TINY,
          FIELD_TYPE_SHORT,
          FIELD_TYPE_LONG,
          FIELD_TYPE_YEAR
                            : if AutoType then Result:= StrToIntDef(S,0) else Result:= S;
          FIELD_TYPE_LONGLONG,
          FIELD_TYPE_INT24,
          FIELD_TYPE_DECIMAL,
          FIELD_TYPE_FLOAT,
          FIELD_TYPE_DOUBLE
                            : if AutoType then Result:= StrToFloatDef(S,0,MysqlFormatSettings) else Result:= S;
          FIELD_TYPE_TIMESTAMP,
          FIELD_TYPE_DATETIME,
          FIELD_TYPE_TIME
                            : if AutoType then Result:= Double(StrToDateTimeDef(S,0,MysqlFormatSettings)) else Result:= S;
          FIELD_TYPE_DATE,
          FIELD_TYPE_NEWDATE
                            : Result:= StrToDateDef(S,0,MysqlFormatSettings);
  else Result:= S
  end;
end;

function TMySQLConnection.ListProcesses(const Param: Variant): Variant;
var R: TMysqlResult;
    I, J: Integer;
    V: Variant;
begin
  Result:= Param;
  try
    if IsEmptyParam(Result) then begin
      if IsV77Application then Result:= GetApplication.EvalExpr('CreateObject("ValueTable")') else  Result:= GetApplication.NewObject('ValueTable')
    end else begin
      if IsV77Application then Result.Clear else Result.Columns.Clear;
    end;
    R:= Client.list_processes;
    if Assigned(R) then try
      for I:= 0 to R.FieldsCount - 1 do
        if IsV77Application then
          Result.NewColumn(String(R.FieldDef(I)^.Name),GetFieldType(I))
        else
          Result.Columns.Add(String(R.FieldDef(I)^.Name));
      R.First; J:= 1;
      while not R.EOF do begin
        if IsV77Application then begin
          Result.NewLine(J);
          for I:= 0 to R.FieldsCount - 1 do
            Result.SetValue(J,I+1,GetFieldValue(I));
        end else begin
          V:= Result.Add();
          for I:= 0 to R.FieldsCount - 1 do
            V.Set(I,GetFieldValue(I));
        end;
        Inc(J);
        R.Next;
      end;
      FreeAndNil(R);
    except end;
  except end;
end;

function TMySQLConnection.PrepareSQL(const OleSQL, Params: OleVariant): String;
var i: Integer;
    V,V1: Variant;
    S: String;
begin
  Result:= OleSQL;
  V1:= Params;
  if VarType(V1) <> varDispatch then Exit;
  try
    for i:= 1 to Params.GetListSize() do begin
      V:= Params.GetValue(i,S);
      Result:= StringReplace(Result,'%'+S+'%',String(V),[rfReplaceAll]);
    end;
  except end;
end;

{ TModule }

procedure TModule.AddinHelperPropertiesHostGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.Host;
end;

procedure TModule.AddinHelperPropertiesHostSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.Host:= String(Value);
end;

procedure TModule.AddinHelperPropertiesUserGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.User;
end;

procedure TModule.AddinHelperPropertiesUserSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.User:= String(Value);
end;

procedure TModule.AddinHelperPropertiesPasswordGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.Password;
end;

procedure TModule.AddinHelperPropertiesUnixSocketGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.UnixSocket;
end;

procedure TModule.AddinHelperPropertiesDbGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.Db;
end;

procedure TModule.AddinHelperPropertiesPortGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.Port;
end;

procedure TModule.AddinHelperPropertiesClientFlagGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.ClientFlag;
end;

procedure TModule.AddinHelperPropertiesShouldReconnectGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.ShouldReconnect);
end;

procedure TModule.AddinHelperPropertiesUseNamedPipeGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.UseNamedPipe);
end;

procedure TModule.AddinHelperPropertiesTrySocketsGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.TrySockets);
end;

procedure TModule.AddinHelperPropertiesConnectTimeoutGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.ConnectTimeout;
end;

procedure TModule.AddinHelperPropertiesCompressGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.Compress);
end;

procedure TModule.AddinHelperPropertiesRecNoGet(Sender: TObject; var Value: OleVariant);
begin
 with TMySQLConnection(Sender) do
  if Assigned(Query) then Value:= Query.RecNo else Value:= -1;
end;

procedure TModule.AddinHelperPropertiesFieldsCountGet(Sender: TObject; var Value: OleVariant);
begin
 with TMySQLConnection(Sender) do
  if Assigned(Query) then Value:= Query.FieldsCount else Value:= -1;
end;

procedure TModule.AddinHelperPropertiesRowsCountGet(Sender: TObject; var Value: OleVariant);
begin
 with TMySQLConnection(Sender) do
  if Assigned(Query) then Value:= Query.RowsCount else Value:= -1;
end;

procedure TModule.AddinHelperPropertiesResultTypeGet(Sender: TObject; var Value: OleVariant);
begin
 with TMySQLConnection(Sender) do
  if Assigned(Query) then Value:= Integer(Query.ResultType) else Value:= -1;
end;

procedure TModule.AddinHelperPropertiesAutoTypeGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).AutoType);
end;

procedure TModule.AddinHelperPropertiesUseNewPasswordGet(Sender: TObject; var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.Use410Password);
end;

procedure TModule.AddinHelperPropertiesPasswordSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.Password:= String(Value);
end;

procedure TModule.AddinHelperPropertiesUnixSocketSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.UnixSocket:= String(Value);
end;

procedure TModule.AddinHelperPropertiesDbSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.Db:= String(Value);
end;

procedure TModule.AddinHelperPropertiesPortSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.Port:= Value;
end;

procedure TModule.AddinHelperPropertiesClientFlagSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.ClientFlag:= Value;
end;

procedure TModule.AddinHelperPropertiesShouldReconnectSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.ShouldReconnect:= Boolean(Value);
end;

procedure TModule.AddinHelperPropertiesUseNamedPipeSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.UseNamedPipe:= Boolean(Value);
end;

procedure TModule.AddinHelperPropertiesTrySocketsSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.TrySockets:= Boolean(Value);
end;

procedure TModule.AddinHelperPropertiesConnectTimeoutSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.ConnectTimeout:= Value;
end;

procedure TModule.AddinHelperPropertiesCompressSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.Compress:= Boolean(Value);
end;

procedure TModule.AddinHelperPropertiesAutoTypeSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).AutoType:= Boolean(Value);
end;

procedure TModule.AddinHelperPropertiesUseNewPasswordSet(Sender: TObject; var Value: OleVariant);
begin
  TMySQLConnection(Sender).Client.Use410Password:= Boolean(Value);
end;

procedure TModule.AddinHelperMethodsStatusCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Integer(TMySQLConnection(Sender).Client.Status);
end;

procedure TModule.AddinHelperMethodsThreadIdCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.ThreadId;
end;

procedure TModule.AddinHelperFindProperty(Sender: TObject;
  const PropertyName: string; var Index: Integer);
begin
  with TMySQLConnection(Sender) do try
    if Assigned(Query) then
      Index:= Query.FieldIndexByName(MidStr(PropertyName,2,MaxInt));
  except end;
end;

procedure TModule.AddinHelperGetProperty(Sender: TObject;
  const PropertyName: string; var Value: OleVariant; var Handled: Boolean);
begin
  with TMySQLConnection(Sender) do
    if Assigned(Query) then begin
      Value:= GetFieldValue(Query.FieldIndexByName(MidStr(PropertyName,2,MaxInt)));
      Handled:= True;
    end;
end;

procedure TModule.AddinHelperGetPropertyCount(Sender: TObject;
  var Count: Integer);
begin
  with TMySQLConnection(Sender) do try
    if Assigned(Query) then Inc(Count,Query.FieldsCount);
  except end;
end;

procedure TModule.AddinHelperGetPropertyName(Sender: TObject;
  var PropertyName: WideString; const Index, Alias: Integer);
var Def: PMysql_FieldDef;
begin
  with TMySQLConnection(Sender) do try
    if Assigned(Query) then begin
      Def:= Query.FieldDef(Index);
      if Assigned(Def) then PropertyName:= '_'+Def^.Name;
    end;
  except end;
end;

procedure TModule.AddinHelperIsPropertyReadable(Sender: TObject;
  const PropertyName: string; var Readable: Boolean);
begin
  with TMySQLConnection(Sender) do try
    if Assigned(Query) then
      Readable:= Assigned(Query.FieldDefByName(MidStr(PropertyName,2,MaxInt)));
  except end;
end;

procedure TModule.AddinHelperIsPropertyWriteable(Sender: TObject;
  const PropertyName: string; var Writeable: Boolean);
begin
  with TMySQLConnection(Sender) do try
    if Assigned(Query) then
      if Assigned(Query.FieldDefByName(MidStr(PropertyName,2,MaxInt))) then Writeable:= False;
  except end;
end;

procedure TModule.AddinHelperMethodsAffectedRowsCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.AffectedRows;
end;

procedure TModule.AddinHelperMethodsLastInsertIdCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.LastInsertId;
end;

procedure TModule.AddinHelperMethodsServerVersionCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.ServerVersion;
end;

procedure TModule.AddinHelperMethodsClientVersionCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.ClientVersion;
end;

procedure TModule.AddinHelperMethodsProtocolVersionCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.ProtocolVersion;
end;

procedure TModule.AddinHelperMethodsServerCapabilitiesCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.ServerCapabilities;
end;

procedure TModule.AddinHelperMethodsServerStatusCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.ServerStatus;
end;

procedure TModule.AddinHelperMethodsServerLanguageCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.ServerLanguage;
end;

procedure TModule.AddinHelperMethodsExtraInfoCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.ExtraInfo;
end;

procedure TModule.AddinHelperMethodsInfoCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.Info;
end;

procedure TModule.AddinHelperMethodsLastErrorCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.LastError;
end;

procedure TModule.AddinHelperMethodsLastErrorNoCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.LastErrorNo;
end;

procedure TModule.AddinHelperMethodsConnectedCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.Connected);
end;

procedure TModule.AddinHelperMethodsConnectCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.connect);
end;

procedure TModule.AddinHelperMethodsConnectCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  TMySQLConnection(Sender).Client.connect;
end;

procedure TModule.AddinHelperMethodsReconnectCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.reconnect);
end;

procedure TModule.AddinHelperMethodsReconnectCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  TMySQLConnection(Sender).Client.reconnect;
end;

procedure TModule.AddinHelperMethodsCloneCallAsFunc(Sender: TObject;
  var Params: array of Variant; var Value: OleVariant);
var V: Variant;
begin
  Value:= Unassigned;
  with TMysqlConnection(Sender) do
    try
      if IsV77Application then
        V:= GetApplication.CreateObject('AddIn.'+Helper.ExtensionName)
      else
        V:= GetApplication.NewObject('AddIn.'+Helper.ExtensionName);
    V.Host:= Client.Host;
    V.User:= Client.User;
    V.Password:= Client.Password;
    V.Db:= Client.Db;
    V.Port:= Client.Port;
    V.UnixSocket := Client.UnixSocket;
    V.ClientFlag := Client.ClientFlag;
    V.ShouldReconnect := Ord(Client.ShouldReconnect);
    V.UseNamedPipe := Ord(Client.UseNamedPipe);
    V.TrySockets := Ord(Client.TrySockets);
    V.ConnectTimeout := Client.ConnectTimeout;
    V.Compress := Ord(Client.Compress);
    if Client.Connected then try
      V.Connect;
    except end;
  if IsV77Application then Value:= IDispatch(V) else Value:= V;
    except end;
end;

procedure TModule.AddinHelperMethodsCloseCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  TMySQLConnection(Sender).Client.close;
end;

procedure TModule.AddinHelperMethodsSelectDbCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.select_db(String(Params[0])));
end;

procedure TModule.AddinHelperMethodsSelectDbCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  TMySQLConnection(Sender).Client.select_db(String(Params[0]));
end;

procedure TModule.AddinHelperMethodsCreateDbCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).CreateDB(String(Params[0])));
end;

procedure TModule.AddinHelperMethodsCreateDbCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  TMySQLConnection(Sender).CreateDB(String(Params[0]));
end;

procedure TModule.AddinHelperMethodsDropDbCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).DropDB(String(Params[0])));
end;

procedure TModule.AddinHelperMethodsDropDbCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  TMySQLConnection(Sender).DropDB(String(Params[0]));
end;

procedure TModule.AddinHelperMethodsChangeUserCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.change_user(String(Params[0]),String(Params[1]),String(Params[2])));
end;

procedure TModule.AddinHelperMethodsChangeUserCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  TMySQLConnection(Sender).Client.change_user(String(Params[0]),String(Params[1]),String(Params[2]));
end;

procedure TModule.AddinHelperMethodsChangeUserGetDefaultParam(Sender: TObject; const Index: Integer;
  var Value: OleVariant);
begin
  if Index = 2 then Value:= '';
end;

procedure TModule.AddinHelperMethodsRefreshCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.refresh(Integer(Params[0])));
end;

procedure TModule.AddinHelperMethodsRefreshCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  TMySQLConnection(Sender).Client.refresh(Integer(Params[0]));
end;

procedure TModule.AddinHelperMethodsKillCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.kill(Integer(Params[0])));
end;

procedure TModule.AddinHelperMethodsKillCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  TMySQLConnection(Sender).Client.kill(Integer(Params[0]));
end;

procedure TModule.AddinHelperMethodsPingCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= Ord(TMySQLConnection(Sender).Client.ping);
end;

procedure TModule.AddinHelperMethodsShutdownCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  with TMySQLConnection(Sender) do
    if Client.shutdown then begin
      Value:= 1;
      if Assigned(Query) then FreeAndNil(Query);
    end else Value:= 0;
end;

procedure TModule.AddinHelperMethodsShutdownCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  with TMySQLConnection(Sender) do
    if Client.shutdown then
      if Assigned(Query) then FreeAndNil(Query);
end;

procedure TModule.AddinHelperMethodsStatCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value:= TMySQLConnection(Sender).Client.stat;
end;

procedure TModule.AddinHelperMethodsQueryCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
var ExecOK: Boolean;
begin
  with TMySQLConnection(Sender) do begin
    if Assigned(Query) then FreeAndNil(Query);
    Query := Client.query(PrepareSQL(Params[0],Params[1]),Params[2] = 1,ExecOK);
    if not ExecOK then if Assigned(Query) then FreeAndNil(Query);
    Value := Ord(ExecOK);
  end;
end;

procedure TModule.AddinHelperMethodsQueryCallAsProc(Sender: TObject; var Params: array of Variant);
var ExecOK: Boolean;
begin
  with TMySQLConnection(Sender) do begin
    if Assigned(Query) then FreeAndNil(Query);
    Query := Client.query(PrepareSQL(Params[0],Params[1]),Params[2] = 1,ExecOK);
    if not ExecOK then if Assigned(Query) then FreeAndNil(Query);
  end;
end;

procedure TModule.AddinHelperMethodsQueryGetDefaultParam(Sender: TObject; const Index: Integer; var Value: OleVariant);
begin
  if Index = 1 then Value:= Null
  else if Index = 2 then Value:= 0;
end;

procedure TModule.AddinHelperMethodsExecuteCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
var ExecOK: Boolean;
    Q: TMysqlResult;
begin
  with TMySQLConnection(Sender) do begin
    Q:= Client.query(PrepareSQL(Params[0],Params[1]),False,ExecOK);
    if ExecOK then Value:= Client.AffectedRows else Value:= -1;
    FreeAndNil(Q);
  end;
end;

procedure TModule.AddinHelperMethodsExecuteCallAsProc(Sender: TObject; var Params: array of Variant);
var ExecOK: Boolean;
    Q: TMysqlResult;
begin
  with TMySQLConnection(Sender) do begin
    Q:= Client.query(PrepareSQL(Params[0],Params[1]),False,ExecOK);
    FreeAndNil(Q);
  end;
end;

procedure TModule.AddinHelperMethodsExecuteGetDefaultParam(Sender: TObject; const Index: Integer;
  var Value: OleVariant);
begin
  if Index = 1 then Value:= Null;
end;

procedure TModule.AddinHelperMethodsLastRowReadCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  with TMySQLConnection(Sender) do
    if Assigned(Query) then Value:= Ord(Query.LastRowRead) else Value:= -1;
end;

procedure TModule.AddinHelperMethodsListProcessesCallAsFunc(
  Sender: TObject; var Params: array of Variant; var Value: OleVariant);
var V: Variant;
begin
  V:= Variant(Params[0]);
  V:= TMySQLConnection(Sender).ListProcesses(V);
  Value:= V;
  Params[0]:= IDispatch(V);
end;

procedure TModule.AddinHelperMethodsListProcessesCallAsProc(
  Sender: TObject; var Params: array of Variant);
var V: Variant;
begin
  V:= Variant(Params[0]);
  V:= TMySQLConnection(Sender).ListProcesses(V);
  Params[0]:= IDispatch(V);
end;

procedure TModule.AddinHelperMethodsListProcessesGetDefaultParam(
  Sender: TObject; const Index: Integer; var Value: OleVariant);
begin
  Value:= Null;
end;

procedure TModule.AddinHelperMethodsEOFCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
begin
  with TMySQLConnection(Sender) do
    if Assigned(Query) then Value:= Ord(Query.EOF) else Value:= -1;
end;

procedure TModule.AddinHelperMethodsBOFCallAsFunc(Sender: TObject; var Params: array of Variant; var Value: OleVariant);
begin
  with TMySQLConnection(Sender) do
    if Assigned(Query) then Value:= Ord(Query.BOF) else Value:= -1;
end;

procedure TModule.AddinHelperMethodsFieldDefCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
var S: String;
    I: Integer;
begin
  with TMySQLConnection(Sender) do begin
    S:= Params[0];
    if Assigned(Query) then begin
      try
        I:= StrToInt(S);
        S:= Query.FieldDef(I)^.Name;
        Value:= OleVariant(S);
      except
        I:= Query.FieldIndexByName(S);
        Value:= OleVariant(I);
      end;
      case Integer(Params[1]) of
        1: Value:= OleVariant(Query.FieldDef(I)^.field_type);
        2: Value:= OleVariant(Query.FieldDef(I)^.Length);
        3: Value:= OleVariant(Query.FieldDef(I)^.Decimals);
        4: Value:= OleVariant(Query.FieldDef(I)^.Flags);
      end;
    end else
      try
        StrToInt(S);
        Value:= '';
      except
        Value:= -1
      end;
    end;
end;

procedure TModule.AddinHelperMethodsFieldDefGetDefaultParam(Sender: TObject; const Index: Integer;
  var Value: OleVariant);
begin
  if Index = 1 then Value:= 0;
end;

procedure TModule.AddinHelperMethodsFieldTypeCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
var S: String;
    I: Integer;
begin
  with TMySQLConnection(Sender) do begin
    S:= Params[0];
    if Assigned(Query) then begin
      try
        I:= StrToInt(S);
      except
        I:= Query.FieldIndexByName(S);
      end;
      Value:= GetFieldType(I);
    end else Value:= '';
 end;
end;

procedure TModule.AddinHelperMethodsNextCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  with TMySQLConnection(Sender) do
    if Assigned(Query) then Query.Next;
end;

procedure TModule.AddinHelperMethodsPriorCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  with TMySQLConnection(Sender) do
    if Assigned(Query) then Query.Prior;
end;

procedure TModule.AddinHelperMethodsFirstCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  with TMySQLConnection(Sender) do
    if Assigned(Query) then Query.First;
end;

procedure TModule.AddinHelperMethodsLastCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  with TMySQLConnection(Sender) do
    if Assigned(Query) then Query.Last;
end;

procedure TModule.AddinHelperMethodsLocateCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  with TMySQLConnection(Sender) do
    if Assigned(Query) then Query.RecNo:= Integer(Params[0]);
end;

procedure TModule.AddinHelperMethodsFetchValueCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
var S: String;
    I: Integer;
begin
  with TMySQLConnection(Sender) do
    if Assigned(Query) then begin
      S:= Params[0];
      try
        I:= StrToInt(S);
        Value:= GetFieldValue(I);
      except
        Value:= GetFieldValue(Query.FieldIndexByName(S));
      end;
    end else Value := '';
end;

procedure TModule.AddinHelperMethodsFetchRowCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
var V: Variant;
    I: Integer;
begin
  with TMySQLConnection(Sender) do begin
    if IsV77Application then V:= GetApplication.EvalExpr('CreateObject("ValueList")') else V:= GetApplication.NewObject('ValueList');
    if Assigned(Query) then begin
      try
        for I:= 0 to Query.FieldsCount - 1 do
          if IsV77Application then
            V.AddValue(GetFieldValue(I),String(Query.FieldDef(I)^.Name))
          else
            V.Add(GetFieldValue(I),String(Query.FieldDef(I)^.Name))
      except end;
    end;
    Value := V;
  end;
end;

procedure TModule.AddinHelperMethodsFetchRowCallAsProc(Sender: TObject; var Params: array of Variant);
var V: Variant;
    I: Integer;
begin
  with TMySQLConnection(Sender) do begin
    if IsV77Application then V:= GetApplication.EvalExpr('CreateObject("ValueList")') else V:= GetApplication.NewObject('ValueList');
    if Assigned(Query) then begin
      try
        for I:= 0 to Query.FieldsCount - 1 do
          if IsV77Application then
            V.AddValue(GetFieldValue(I),String(Query.FieldDef(I)^.Name))
          else
            V.Add(GetFieldValue(I),String(Query.FieldDef(I)^.Name));
      except end;
    end;
    Params[0] := IDispatch(V);
  end;
end;

procedure TModule.AddinHelperMethodsFetchRowGetDefaultParam(Sender: TObject; const Index: Integer;
  var Value: OleVariant);
begin
  Value:= Null;
end;

procedure TModule.AddinHelperMethodsFetchAllCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
begin
  Value := TMySQLConnection(Sender).FetchAll(Null);
end;

procedure TModule.AddinHelperMethodsFetchAllCallAsProc(Sender: TObject; var Params: array of Variant);
begin
  Params[0] := IDispatch(TMySQLConnection(Sender).FetchAll(Null));
end;

procedure TModule.AddinHelperMethodsFetchAllGetDefaultParam(Sender: TObject; const Index: Integer;
  var Value: OleVariant);
begin
  Value:= Null;
end;

procedure TModule.AddinHelperMethodsFillAllCallAsFunc(Sender: TObject; var Params: array of Variant;
  var Value: OleVariant);
var V: Variant;
begin
  V:= Variant(Params[0]);
  V := TMySQLConnection(Sender).FetchAll(V);
  Value:= V;
  Params[0] := IDispatch(V);
end;

procedure TModule.AddinHelperMethodsFillAllCallAsProc(Sender: TObject; var Params: array of Variant);
var V: Variant;
begin
  V:= Variant(Params[0]);
  V := TMySQLConnection(Sender).FetchAll(V);
  Params[0] := IDispatch(V);
end;

initialization
  MysqlFormatSettings.ThousandSeparator:= #0;
  MysqlFormatSettings.DecimalSeparator:= '.';
  MysqlFormatSettings.CurrencyDecimals:= 2;
  MysqlFormatSettings.DateSeparator:= '-';
  MysqlFormatSettings.TimeSeparator:= ':';
  MysqlFormatSettings.ListSeparator:= ';';
  MysqlFormatSettings.LongDateFormat:= 'yyyy-MM-dd';
  MysqlFormatSettings.ShortDateFormat:= 'yyyy-MM-dd';
  MysqlFormatSettings.TimeAMString:= '';
  MysqlFormatSettings.TimePMString:= '';
  MysqlFormatSettings.ShortTimeFormat:= 'HH:mm:ss';
  MysqlFormatSettings.LongTimeFormat:= 'HH:mm:ss';
  MysqlFormatSettings.ShortMonthNames[1]:= 'Jan';
  MysqlFormatSettings.ShortMonthNames[2]:= 'Feb';
  MysqlFormatSettings.ShortMonthNames[3]:= 'Mar';
  MysqlFormatSettings.ShortMonthNames[4]:= 'Apr';
  MysqlFormatSettings.ShortMonthNames[5]:= 'May';
  MysqlFormatSettings.ShortMonthNames[6]:= 'Jun';
  MysqlFormatSettings.ShortMonthNames[7]:= 'Jul';
  MysqlFormatSettings.ShortMonthNames[8]:= 'Aug';
  MysqlFormatSettings.ShortMonthNames[9]:= 'Sep';
  MysqlFormatSettings.ShortMonthNames[10]:= 'Oct';
  MysqlFormatSettings.ShortMonthNames[11]:= 'Nov';
  MysqlFormatSettings.ShortMonthNames[12]:= 'Dec';
  MysqlFormatSettings.LongMonthNames[1]:= 'January';
  MysqlFormatSettings.LongMonthNames[2]:= 'February';
  MysqlFormatSettings.LongMonthNames[3]:= 'March';
  MysqlFormatSettings.LongMonthNames[4]:= 'April';
  MysqlFormatSettings.LongMonthNames[5]:= 'May';
  MysqlFormatSettings.LongMonthNames[6]:= 'June';
  MysqlFormatSettings.LongMonthNames[7]:= 'July';
  MysqlFormatSettings.LongMonthNames[8]:= 'August';
  MysqlFormatSettings.LongMonthNames[9]:= 'September';
  MysqlFormatSettings.LongMonthNames[10]:= 'October';
  MysqlFormatSettings.LongMonthNames[11]:= 'November';
  MysqlFormatSettings.LongMonthNames[12]:= 'December';
  MysqlFormatSettings.ShortDayNames[1]:= 'Sun';
  MysqlFormatSettings.ShortDayNames[2]:= 'Mon';
  MysqlFormatSettings.ShortDayNames[3]:= 'Tue';
  MysqlFormatSettings.ShortDayNames[4]:= 'Wed';
  MysqlFormatSettings.ShortDayNames[5]:= 'Thu';
  MysqlFormatSettings.ShortDayNames[6]:= 'Fri';
  MysqlFormatSettings.ShortDayNames[7]:= 'Sat';
  MysqlFormatSettings.LongDayNames[1]:= 'Sunday';
  MysqlFormatSettings.LongDayNames[2]:= 'Monday';
  MysqlFormatSettings.LongDayNames[3]:= 'Tuesday';
  MysqlFormatSettings.LongDayNames[4]:= 'Wednesday';
  MysqlFormatSettings.LongDayNames[5]:= 'Thursday';
  MysqlFormatSettings.LongDayNames[6]:= 'Friday';
  MysqlFormatSettings.LongDayNames[7]:= 'Saturday';
  MysqlFormatSettings.TwoDigitYearCenturyWindow:= 2029;
  MysqlFormatSettings.CurrencyFormat:= 3;
  MysqlFormatSettings.NegCurrFormat:= 3;
  MysqlFormatSettings.CurrencyString:= '.';

  ComServer.SetServerName('AddIn');
  TComObjectFactory.Create(ComServer,TMySQLConnection,CLSID_MySQLConnection,
                        'MySQLConnection','IC V7 AddIn 2.0',ciMultiInstance,tmApartment);

end.
